<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      MioCart 3.5                                                       
           MioCart PHP Shopping Cart - MioCart.Com 17/08/2008              ***
  ***                                                                      ***
  ****************************************************************************
*/


	include_once("./includes/common.php");
	include_once("./includes/navigator.php");
	include_once("./includes/record.php");
	include_once("./includes/editgrid.php");
	include_once("./messages/" . $language_code . "/cart_messages.php");
	include_once("./messages/" . $language_code . "/reviews_messages.php");
	include_once("./messages/" . $language_code . "/support_messages.php");
	include_once("./messages/" . $language_code . "/manuals_messages.php");

	// include blocks
	include_once("./blocks/block_articles_categories.php");
	include_once("./blocks/block_articles_breadcrumb.php");
	include_once("./blocks/block_articles_list.php");
	include_once("./blocks/block_articles_latest.php");
	include_once("./blocks/block_articles_top_rated.php");
	include_once("./blocks/block_articles_top_viewed.php");
	include_once("./blocks/block_articles_hot.php");
	include_once("./blocks/block_articles_content.php");
	include_once("./blocks/block_articles_search.php");
	include_once("./blocks/block_custom.php");
	include_once("./blocks/block_banners.php");
	include_once("./blocks/block_poll.php");

	$page_name = "manuals_article_details";
	$page_settings = va_page_settings($page_name, 0);
	
	$article_id = get_param("article_id");	
	// retrieve info about current article
	if ($article_id) {
		$sql  = " SELECT ma.article_title";
		$sql .= " FROM ((";
		if (isset($site_id)) {
			$sql .= "(";
		}
		$sql .= $table_prefix . "manuals_articles ma ";
		$sql .= " INNER JOIN " . $table_prefix . "manuals_list ml ON ml.manual_id = ma.manual_id)";
		$sql .= " INNER JOIN " . $table_prefix . "manuals_categories mc ON mc.category_id = ml.category_id)";
		if (isset($site_id)) {
			$sql .= " LEFT JOIN " . $table_prefix . "manuals_categories_sites mcs ON mcs.category_id=mc.category_id)";
		}
		$sql .= " WHERE ma.article_id=".$db->tosql($article_id, INTEGER);
		$sql .= " AND ma.allowed_view = 1 AND ml.allowed_view = 1 AND mc.allowed_view=1 ";	
		if (isset($site_id)) {
			$sql .= " AND (mc.sites_all=1 OR mcs.site_id=". $db->tosql($site_id, INTEGER, true, false) . ") ";
		} else {
			$sql .= " AND mc.sites_all=1 ";					
		}
		$db->query($sql);
		if (!$db->next_record()) {
			header ("Location: " . get_custom_friendly_url("manuals.php"));
			exit;			
		}
	}

	$t = new VA_Template($settings["templates_dir"]);
	$t->set_file("main","manuals_article_details.html");
	$t->set_var("current_href", "manuals_article_details.php");

	include_once("./header.php");


	if (is_array($page_settings)) {
		foreach($page_settings as $setting_name => $setting_value)
		{
			if (preg_match("/^a_cats_(\d+)$/", $setting_name, $matches)) {
				articles_categories($setting_value, $matches[1], $top_name, "a_cats", $category_id);
			} elseif (preg_match("/^a_subcats_(\d+)$/", $setting_name, $matches)) {
				articles_categories($setting_value, $matches[1], $top_name, "a_subcats", $category_id);
			} elseif (preg_match("/^a_breadcrumb_(\d+)$/", $setting_name, $matches)) {
				articles_breadcrumb($setting_value, $matches[1], $rss_on_breadcrumb);
			} elseif (preg_match("/^a_list_(\d+)$/", $setting_name, $matches)) {
				articles_list($setting_value, $matches[1], $list_fields, $articles_order_column, $articles_order_direction, $current_category, $list_template);
			} elseif (preg_match("/^a_latest_(\d+)$/", $setting_name, $matches)) {
				articles_latest($setting_value, $matches[1], $top_name);
			} elseif (preg_match("/^a_top_rated_(\d+)$/", $setting_name, $matches)) {
				articles_top_rated($setting_value, $matches[1], $top_name);
			} elseif (preg_match("/^a_top_viewed_(\d+)$/", $setting_name, $matches)) {
				articles_top_viewed($setting_value, $matches[1], $top_name);
			} elseif (preg_match("/^a_hot_(\d+)$/", $setting_name, $matches)) {
				articles_hot($setting_value, $matches[1], $top_name, $list_fields, $articles_order_column, $articles_order_direction, $category_id);
			} elseif (preg_match("/^a_content_(\d+)$/", $setting_name, $matches)) {
				articles_content($setting_value, $matches[1], $category_id, $current_category, $articles_order_column, $articles_order_direction);
			} elseif (preg_match("/^a_search_(\d+)$/", $setting_name, $matches)) {
				articles_search($setting_value, $matches[1], $top_name, $category_id);
			} elseif ($setting_name == "cart_block") {
				include_once("./blocks/block_cart.php");
				small_cart($setting_value);
			} elseif ($setting_name == "login_block") {
				login_form($setting_value);
			} elseif ($setting_name == "subscribe_block") {
				include_once("./blocks/block_subscribe.php");
				subscribe_form($setting_value);
			} elseif ($setting_name == "sms_test_block") {
				include_once("./blocks/block_sms_test.php");
				sms_test_form($setting_value);
			} elseif ($setting_name == "poll_block") {
				poll_form($setting_value);
			} elseif ($setting_name == "language_block") {
				include_once("./blocks/block_language.php");
				language_form($setting_value, $page_settings["language_selection"]);
			} elseif ($setting_name == "currency_block") {
				include_once("./blocks/block_currency.php");
				currency_form($setting_value);
			} elseif ($setting_name == "layouts_block") {
				include_once("./blocks/block_layouts.php");
				layouts($setting_value);
			} elseif ($setting_name == "site_search_form") {
				include_once("./blocks/block_site_search_form.php");
				site_search_form($setting_value);
			} elseif (preg_match("/^navigation_block_(\d+)$/", $setting_name, $matches)) {
				include_once("./blocks/block_navigation.php");
				navigation_menu($setting_value, $matches[1]);
			} elseif (preg_match("/^custom_block_/", $setting_name)) {
				custom_block($setting_value, substr($setting_name, 13));
			} elseif (preg_match("/^banners_group_/", $setting_name)) {
				banners_group($setting_value, substr($setting_name, 14));
			} elseif ($setting_name == "manuals_articles") {
				include_once("./blocks/block_manuals_articles.php");
				manuals_articles($setting_value);
			} elseif ($setting_name == "manuals_article_details") {
				include_once("./blocks/block_manuals_article_details.php");
				manuals_article_details($setting_value);
			} elseif ($setting_name == "manuals_search") {
				include_once("./blocks/block_manuals_search.php");
				manuals_search($setting_value);
			} elseif ($setting_name == "manuals_breadcrumb") {
				include_once("./blocks/block_manuals_breadcrumb.php");
				manuals_breadcrumb($setting_value);				
			}
		}
	}

	if (!get_setting_value($page_settings, "left_column_hide", 0)) {
		$t->set_var("left_column_width", get_setting_value($page_settings, "left_column_width", "20%"));
		$t->parse("left_column", false);
	}
	if (!get_setting_value($page_settings, "middle_column_hide", 0)) {
		$t->set_var("middle_column_width", get_setting_value($page_settings, "middle_column_width", "60%"));
		$t->parse("middle_column", false);
	}
	if (!get_setting_value($page_settings, "right_column_hide", 0)) {
		$t->set_var("right_column_width", get_setting_value($page_settings, "right_column_width", "20%"));
		$t->parse("right_column", false);
	}

	include_once("./footer.php");

	$t->pparse("main");
	
?>